<?php
/**
 * @package		eWAY Rapid3.0 Payment Gateway
 * @version		1.0.0
 * @author		web.texidor.com
 * @copyright	2012 Nick Texidor. All rights reserved.
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

defined('_JEXEC') or die('Restricted access');

?>
<?php
class plgHikashoppaymentEwayRapid extends JPlugin{
	var $debugData = array();

	function onPaymentDisplay(&$order,&$methods,&$usable_methods){
		if (!empty($methods)){
			foreach($methods as $method) {
				if($method->payment_type != 'ewayrapid' || !$method->enabled) {
					continue;
				}

				if (!empty($method->payment_zone_namekey)) {
					$zoneClass	= hikashop_get('class.zone');
					$zones 		= $zoneClass->getOrderZones($order);

					if (!in_array($method->payment_zone_namekey,$zones)) {
						return true;
					}
				}

				$usable_methods[$method->ordering] = $method;
			}
		}

		return true;
	}

	function onPaymentSave(&$cart,&$rates,&$payment_id)
	{
		$usable = array();
		$this->onPaymentDisplay($cart,$rates,$usable);
		$payment_id = (int) $payment_id;

		foreach($usable as $usable_method){
			if($usable_method->payment_id==$payment_id){
				return $usable_method;
			}
		}
		return false;
	}


	function onAfterOrderConfirm(&$order, &$methods, $method_id)
	{
		$app 				= JFactory::getApplication();

		if ($app->isAdmin()){
			return true;
		}

		if (empty($order->order_payment_method) || $order->order_payment_method!='ewayrapid'){
			return true;
		}

		$db 				= JFactory::getDBO();
		$query 				= 'SELECT * FROM '.hikashop_table('payment').' WHERE payment_type='.$db->Quote($order->order_payment_method);
		$db->setQuery($query);

		$paymentData 		= $db->loadObjectList('payment_id');
		$pluginsClass 		= hikashop_get('class.plugins');
		$pluginsClass->params($paymentData,'payment');

		$method 			=& $paymentData[$order->order_payment_id];

		$currencyClass 		= hikashop_get('class.currency');
		$currencies			= null;
		$currencies 		= $currencyClass->getCurrencies($order->order_currency_id,$currencies);
		$currency			= $currencies[$order->order_currency_id];

		$user 				= hikashop_loadUser(true);

		$cart 				= hikashop_get('class.cart');

		require_once(realpath(dirname(__FILE__) . '/eWAY/RapidAPI.php'));

		$username 	= $method->payment_params->eway_user;
		$password 	= $method->payment_params->eway_pass;
		$sandbox 	= $method->payment_params->sandbox ? true : false;
		$debug 		= $method->payment_params->debug ? true : false;
		$rmethod 	= $method->payment_params->eway_method;
		$rformat 	= $method->payment_params->eway_format;
		$send_add 	= $method->payment_params->send_address ? true : false;

		$eway_service = new RapidAPI($sandbox, $username, $password, $debug, $rmethod, $rformat);

		$request = new CreateAccessCodeRequest();

		$request->Customer->Reference = 'hikashop';

		$billing_address	= $app->getUserState( HIKASHOP_COMPONENT.'.billing_address');
		if (!empty($billing_address)){
			$cart->loadAddress($order->cart, $billing_address,'object','billing');

			$title_array 						= array('Mr', 'Ms', 'Mrs', 'Dr', 'Sir', 'Prof');
			$temp_title	 						= @$order->cart->billing_address->address_title;
			$user_title 						= (isset($temp_title) && in_array($temp_title, $title_array)) ? $temp_title . '.' : 'Mr.';

			$request->Customer->Title 			= $user_title;
			$request->Customer->FirstName 		= strval(substr(@$order->cart->billing_address->address_firstname, 0, 50));
			$request->Customer->LastName  		= strval(substr(@$order->cart->billing_address->address_lastname, 0, 50));
			$request->Customer->CompanyName  	= strval(substr(@$order->cart->billing_address->address_lastname, 0, 50));
			$request->Customer->Country 		= strval(@$order->cart->billing_address->address_country->zone_code_2);
			$request->Customer->Email 			= substr($user->user_email, 0, 50);
			$request->Customer->Phone 			= strval(substr(@$order->cart->billing_address->address_telephone, 0, 32));

			if ($send_add) {
				$request->Customer->Street1 	= strval(substr(@$order->cart->billing_address->address_street, 0, 50));
				$request->Customer->Street2 	= strval(substr(@$order->cart->billing_address->address_street2, 0, 50));
				$request->Customer->City 		= strval(substr(@$order->cart->billing_address->address_city, 0, 50));
				$request->Customer->State 		= strval(substr(@$order->cart->billing_address->address_state->zone_name_english, 0, 50));
				$request->Customer->PostalCode 	= strval(substr(@$order->cart->billing_address->address_post_code, 0, 30));
			}
		}

		$shipping_address	= $app->getUserState( HIKASHOP_COMPONENT.'.shipping_address');
		if (!empty($shipping_address)){
			$cart->loadAddress($order->cart, $shipping_address,'object','shipping');

			$request->ShippingAddress->FirstName 		= strval(substr(@$order->cart->shipping_address->address_firstname, 0, 50));
			$request->ShippingAddress->LastName  		= strval(substr(@$order->cart->shipping_address->address_lastname, 0, 50));
			$request->ShippingAddress->Country 			= strval(@$order->cart->shipping_address->address_country->zone_code_2);
			$request->ShippingAddress->Email 			= substr($user->user_email, 0, 50);
			$request->ShippingAddress->Phone 			= strval(substr(@$order->cart->shipping_address->address_telephone, 0, 32));
			$request->ShippingAddress->ShippingMethod 	= "Unknown";

			if ($send_add) {
				$request->ShippingAddress->Street1 		= strval(substr(@$order->cart->shipping_address->address_street, 0, 50));
				$request->ShippingAddress->Street2 		= strval(substr(@$order->cart->shipping_address->address_street2, 0, 50));
				$request->ShippingAddress->City 		= strval(substr(@$order->cart->shipping_address->address_city, 0, 50));
				$request->ShippingAddress->State 		= strval(substr(@$order->cart->shipping_address->address_state->zone_name_english, 0, 50));
				$request->ShippingAddress->PostalCode 	= strval(substr(@$order->cart->shipping_address->address_post_code, 0, 30));
			}
		}

		$invoiceNum								= '';
				$invoiceDesc 							= '';

		$config =& hikashop_config();
		$group = $config->get('group_options',0);
		foreach($order->cart->products as $product){
			if($group && $product->order_product_option_parent_id) continue;
			$item 								= new EwayLineItem();
			$item->SKU 							= substr($product->order_product_code, 0, 12);
			$item->Description 					= substr($product->order_product_name, 0, 26);
			$item->Quantity 					= $product->order_product_quantity;
			$request->Items->LineItem[] 		= $item;

			$invoiceDesc 					   .= $product->order_product_name . ', ';
		}

		$invoiceNum								= $order->cart->order_id;
		$invoiceDesc 							= substr($invoiceDesc, 0, -2);

		if (strlen($invoiceDesc) > 64) {
			$invoiceDesc 						= substr($invoiceDesc , 0 , 61) . '...';
		}

		$session 								= JFactory::getSession();
		$return_context 						= $session->getId();

		$opt1 									= new EwayOption();
		$opt1->Value 							= $return_context;
		$request->Options->Option[0]			= $opt1;

		$opt2 									= new EwayOption();
		$opt2->Value 							= $invoiceNum;
		$request->Options->Option[1]			= $opt2;

//        $request->Payment->TotalAmount 			= round($order->cart->full_total->prices[0]->price_value_with_tax, (int)$currency->currency_locale['int_frac_digits']) * 100;
//		Added strval() to correct a bug in PHP that converts (float)1999 to (int)1998.
		$request->Payment->TotalAmount 			= intval(strval(round($order->cart->full_total->prices[0]->price_value_with_tax, (int)$currency->currency_locale['int_frac_digits']) * 100));
		$request->Payment->InvoiceNumber 		= $invoiceNum;
		$request->Payment->InvoiceDescription 	= $invoiceDesc;
		$request->Payment->InvoiceReference 	= $order->order_number;
		$request->Payment->CurrencyCode 		= $currency->currency_code;

		$lang 									= &JFactory::getLanguage();
		$locale									= strtolower(substr($lang->get('tag'),0,2));
		$notify_url								= HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=ewayrapid&tmpl=component&lang=' . $locale;
		$request->RedirectUrl 					= $notify_url;
		$request->Method 						= 'ProcessPayment';

		//Call RapidAPI
		$result 								= $eway_service->CreateAccessCode($request);

		if (isset($result->Errors)) {
			//Get Error Messages from Error Code. Error Code Mappings are in the Config.ini file
			$ErrorArray = explode(",", $result->Errors);
			$lblError = "";
			foreach ( $ErrorArray as $error ) {
				if (isset($eway_service->APIConfig[$error]))
					$lblError .= $error." ".$eway_service->APIConfig[$error]."<br>";
				else
					$lblError .= $error;
			}
		}

		if (isset($lblError)) {
			$html = "Error to proceeding your request: $lblError";
		} else {
			$AccessCode 	= $result->AccessCode;
			$gateway_url	= $result->FormActionURL;
		}

		$viewType 			= '_end';
//		$this->removeCart 	= true;

		JHTML::_('behavior.mootools');
		$app 				= JFactory::getApplication();
		$name 				= $method->payment_type.$viewType.'.php';
		$path 				= JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;

		if (!file_exists($path)) {
			if (version_compare(JVERSION,'1.6','<')) {
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
			} else {
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
			}

			if (!file_exists($path)) {
				return true;
			}
		}

		require($path);
		return true;
	}


	function onPaymentNotification(&$statuses)
	{
		$pluginsClass 			= hikashop_get('class.plugins');
		$elements 				= $pluginsClass->getMethods('payment','ewayrapid');

		if(empty($elements)) return false;

		$element 				= reset($elements);

			$payment_data 			= JRequest::get('request');

				$isError 				= false;

				if (isset($payment_data['AccessCode']) || isset($payment_data['amp;AccessCode'])) {

						require_once(realpath(dirname(__FILE__).'/eWAY/RapidAPI.php'));

						$username 			= $element->payment_params->eway_user;
						$password 			= $element->payment_params->eway_pass;
						$sandbox 			= $element->payment_params->sandbox ? true : false;
						$debug 				= $element->payment_params->debug ? true : false;
						$rmethod 			= $element->payment_params->eway_method;
						$rformat 			= $element->payment_params->eway_format;

						$eway_service 		= new RapidAPI($sandbox, $username, $password, $debug, $rmethod, $rformat);

						$request 			= new GetAccessCodeResultRequest();

						if (isset($payment_data['amp;AccessCode'])) {
								$request->AccessCode = $payment_data['amp;AccessCode'];
						} else {
								$request->AccessCode = $payment_data['AccessCode'];
						}

						//Call RapidAPI to get the result
						$result 			= $eway_service->GetAccessCodeResult($request);

						// Check if any error returns
						if (isset($result->Errors)) {

								// Get Error Messages from Error Code. Error Code Mappings are in the Config.ini file
								$ErrorArray 	= explode(",", $result->Errors);
								$lblError 		= "";
								$isError 		= true;

								foreach ($ErrorArray as $error) {
										$error 		= trim($error);
										$lblError  .= $eway_service->APIConfig[$error]."<br>";
								}

								$html 			= 'Payment Error: ' . $lblError;
								return NULL;
						}

						if (!$isError) {
								if (!$result->TransactionStatus) {
										$isError 	= true;
										$lblError 	= "Payment Declined - " . $result->ResponseCode;
								}
						}
				}

				$return_context 	= $result->Options->Option[0]->Value;
				$order_id 			= $result->Options->Option[1]->Value;

		$orderClass = hikashop_get('class.order');
		$dbOrder = $orderClass->get((int)@$order_id);

		if(empty($dbOrder)){
			echo "Could not load any order for your notification " . @$order_id;
			return false;
		}

		$order 								= null;
		$order->order_id 					= $dbOrder->order_id;
		$order->old_status->order_status 	= $dbOrder->order_status;

		global $Itemid;
		$url_itemid							= '';
		if (!empty($Itemid)) {
			$url_itemid						= '&Itemid=' . $Itemid;
		}

		$app 								= JFactory::getApplication();

		$noMoreHttps 						= str_replace('https://','http://', HIKASHOP_LIVE);

		$url 								= HIKASHOP_LIVE . 'administrator/index.php?option=com_hikashop&ctrl=order&task=edit&order_id=' . $order->order_id;
		$cancel_url 						= HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id=' . $order->order_id . $url_itemid;

		// This URL redirects to the Order Page, but doesn't clear the cart
//		$return_url 						= HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=order&task=show&order_id=' . $order->order_id . $url_itemid;

		// This URL redirects to a blank page, but does clear the cart
		$return_url 						= HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id=' . $order->order_id . $url_itemid;

		$order_text 						= "\r\n" . JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE', $dbOrder->order_number, HIKASHOP_LIVE);
		$order_text 					   .= "\r\n" . str_replace('<br/>', "\r\n", JText::sprintf('ACCESS_ORDER_WITH_LINK', $url));

		if($element->payment_params->debug){
			echo print_r($dbOrder,true)."\n\n\n";
		}

		$currencyClass 						= hikashop_get('class.currency');
		$currencies 						= null;
		$currencies 						= $currencyClass->getCurrencies($dbOrder->order_currency_id, $currencies);
		$currency 							= $currencies[$dbOrder->order_currency_id];

//		$orderPrice 						= round($dbOrder->order_full_price * 100);
		$orderPrice 						= round($dbOrder->order_full_price);
		$orderCurrency 						= $currency->currency_code;

		$mailer				 				=& JFactory::getMailer();
		$config 							=& hikashop_config();
		$sender 							= array(
												$config->get('from_email'),
												$config->get('from_name') );

		$mailer->setSender($sender);
		$mailer->addRecipient(explode(',', $config->get('payment_notification_email')));

		if ($isError) {
			$order->order_status 					= 'cancelled';

			$order->history->history_reason 		= JText::_('NOTIFICATION_REFUSED_FOR_THE_ORDER');
			$order->history->history_notified 		= 0;
			$order->history->history_payment_id 	= $element->payment_id;
			$order->history->history_payment_method = $element->payment_type;
			$order->history->history_data 			= $lblError; // "Payment by eWay - eWay transaction ID: " . $result->TransactionID;
			$order->history->history_type 			= 'payment';

			$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','eWAY') . 'invalid response');
			$body 									= JText::sprintf("Hello,\r\n An eWAY transaction was refused because the notification from the eWAY server was invalid")."\r\n\r\n" . $order_text;

			$mailer->setBody($body);
			$mailer->Send();

			$orderClass->save($order);

			$app->enqueueMessage('Transaction Failed: ' . $lblError);
			$app->redirect($cancel_url);

			return false;
		}

		$order->order_status 					= $element->payment_params->verified_status;

		$order->history->history_reason			= JText::sprintf('AUTOMATIC_PAYMENT_NOTIFICATION');
		$order->history->history_notified		= 1;
		$order->history->history_amount 		= $orderPrice . $orderCurrency;
		$order->history->history_payment_id 	= $element->payment_id;
		$order->history->history_payment_method = $element->payment_type;
		$order->history->history_data 			= '';
		$order->history->history_type 			= 'payment';

	 	$order->mail_status						= $statuses[$order->order_status];

		$url 									= HIKASHOP_LIVE.'administrator/index.php?option=com_hikashop&ctrl=order&task=listing';

		if ($dbOrder->order_status == $order->order_status) {
			return true;
		}

		$order_text 							= "\r\n" . JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE', $dbOrder->order_number, HIKASHOP_LIVE);
		$order_text 						   .= "\r\n" . str_replace('<br/>', "\r\n",JText::sprintf('ACCESS_ORDER_WITH_LINK' , $url));

		$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER', 'eWAY', 'Accepted', $dbOrder->order_number));

		$body = str_replace('<br/>', "\r\n", JText::sprintf('PAYMENT_NOTIFICATION_STATUS', 'eWAY', 'Accepted')) . ' ' . JText::sprintf('ORDER_STATUS_CHANGED', $order->order_status) . "\r\n\r\n" . $order_text;

		$mailer->setBody($body);
		$mailer->Send();

	 	$orderClass->save($order);

		$app->redirect($return_url);

		return true;
	}


	function onPaymentConfiguration(&$element)
	{
		$subtask = JRequest::getCmd('subtask','');
		$this->ewayrapid = JRequest::getCmd('name','ewayrapid');

		if(empty($element)){
			$element = new stdClass();
			$element->payment_name='eWAY';
			$element->payment_description='You can pay by credit card using this payment method';
			$element->payment_images='MasterCard,VISA,Credit_card,American_Express';
			$element->payment_type=$this->ewayrapid;
			$element->payment_params= new stdClass();
			$element->payment_params->invalid_status='cancelled';
			$element->payment_params->pending_status='created';
			$element->payment_params->verified_status='confirmed';
			$element = array($element);
		}

		$bar = & JToolBar::getInstance('toolbar');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::cancel();
		JToolBarHelper::divider();
		$bar->appendButton( 'Pophelp','payment-ewayrapid-form');
		hikashop_setTitle('eWAY (Rapid 3.0)','plugin','plugins&plugin_type=payment&task=edit&name='.$this->ewayrapid);
		$app =& JFactory::getApplication();
		$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->ewayrapid);
		$this->address = hikashop_get('type.address');
		$this->category = hikashop_get('type.categorysub');
		$this->category->type = 'status';
	}

	function onPaymentConfigurationSave(&$element)
	{
		return true;
	}
}
